# Generated by Django 4.1.6 on 2023-05-03 20:13

import uuid
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone
from django.db.migrations import RunPython
import medux.common.models
from django.utils.translation import gettext_lazy as _

from medux.plugins.timetracker.constants import (
    ABSENCE_TYPE_ILLNESS,
    ABSENCE_TYPE_HOLIDAY,
    ABSENCE_TYPE_SPECIAL,
    ABSENCE_TYPE_TRAINING,
    ABSENCE_TYPE_CTO,
)

absence_type_presets = dict(
    ILLNESS=dict(
        uuid=ABSENCE_TYPE_ILLNESS,
        label=_("Sick leave"),
        color="dark",
        needs_approval=True,
    ),
    HOLIDAY=dict(
        uuid=ABSENCE_TYPE_HOLIDAY,
        label=_("Holiday"),
        color="orange",
        needs_approval=True,
    ),
    SPECIAL=dict(
        uuid=ABSENCE_TYPE_SPECIAL,
        label=_("Special"),
        color="yellow",
        needs_approval=True,
    ),
    TRAINING=dict(
        uuid=ABSENCE_TYPE_TRAINING,
        label="Training",
        color="pink",
        needs_approval=True,
    ),
    CTO=dict(
        uuid=ABSENCE_TYPE_CTO,
        label=_("CTO"),
        color="lime",
        needs_approval=False,
    ),
)


def create_vendor_absencetype_presets(apps, schema_editor):
    """Creates global AbsenceType presets with hardcoded preset data."""
    AbsenceType = apps.get_model("timetracker", "AbsenceType")
    for name, preset in absence_type_presets.items():
        # override label, color, needs_approval from preset
        AbsenceType.objects.create(**preset)


old_absence_types_map = dict(
    ill=ABSENCE_TYPE_ILLNESS,
    holiday=ABSENCE_TYPE_HOLIDAY,
    holiday_special=ABSENCE_TYPE_SPECIAL,
    training=ABSENCE_TYPE_TRAINING,
)


def migrate_absence_types(apps, schema_editor):
    Absence = apps.get_model("timetracker", "Absence")
    AbsenceType = apps.get_model("timetracker", "AbsenceType")
    for absence in Absence.objects.all():
        absence.absence_type = AbsenceType.objects.get(
            uuid=old_absence_types_map[absence.type]
        )
        absence.save()


class Migration(migrations.Migration):
    dependencies = [
        ("employees", "0009_workingcontract_holiday_year_is_calendar_year"),
        ("common", "0003_alter_commonuser_tenant"),
        (
            "timetracker",
            "0011_alter_timebalanceentry_options_timeentry_created_and_more",
        ),
    ]

    operations = [
        migrations.CreateModel(
            name="AbsenceBalance",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "created",
                    models.DateTimeField(
                        default=django.utils.timezone.now, editable=False
                    ),
                ),
                (
                    "modified",
                    medux.common.models.AutoDateTimeField(
                        default=django.utils.timezone.now
                    ),
                ),
                ("day", models.DateField(verbose_name="Date")),
                ("balance", models.FloatField(blank=True, verbose_name="Balance")),
                (
                    "comment",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Comment"
                    ),
                ),
            ],
            options={
                "verbose_name": "Absence balance",
                "verbose_name_plural": "Absence balance entries",
                "ordering": ["created"],
            },
        ),
        migrations.CreateModel(
            name="AbsenceType",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("uuid", models.UUIDField(default=uuid.uuid4)),
                (
                    "maintainer",
                    models.SmallIntegerField(
                        choices=[(1, "Vendor"), (2, "Tenant")], default=2
                    ),
                ),
                ("label", models.CharField(max_length=255, verbose_name="Label")),
                (
                    "color",
                    models.CharField(
                        choices=[
                            ("dark", "Dark"),
                            ("azure", "Azure"),
                            ("indigo", "Indigo"),
                            ("purple", "Purple"),
                            ("pink", "Pink"),
                            ("red", "Red"),
                            ("orange", "Orange"),
                            ("yellow", "Yellow"),
                            ("lime", "Lime"),
                        ],
                        default="orange",
                        max_length=50,
                    ),
                ),
                ("active", models.BooleanField(default=True)),
                ("needs_approval", models.BooleanField(default=True)),
                (
                    "public",
                    models.BooleanField(
                        default=False,
                        help_text="Is this absence type publicly visible?",
                    ),
                ),
                (
                    "tenant",
                    models.ForeignKey(
                        blank=True,
                        help_text="The tenant this absence type belongs to",
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="absence_types",
                        to="common.tenant",
                    ),
                ),
            ],
            options={
                "verbose_name": "Absence type",
                "verbose_name_plural": "Absence types",
                "unique_together": {("tenant", "uuid")},
            },
        ),
        migrations.CreateModel(
            name="HolidayEntitlement",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "created",
                    models.DateTimeField(
                        default=django.utils.timezone.now, editable=False
                    ),
                ),
                (
                    "modified",
                    medux.common.models.AutoDateTimeField(
                        default=django.utils.timezone.now
                    ),
                ),
                ("start_date", models.DateField(verbose_name="Start date")),
                ("end_date", models.DateField(verbose_name="End date")),
                (
                    "expired_at",
                    models.DateField(
                        blank=True, null=True, verbose_name="Expiration date"
                    ),
                ),
                (
                    "holidays",
                    models.FloatField(
                        default=0,
                        help_text="Holiday entitlement in days",
                        verbose_name="Holiday entitlement",
                    ),
                ),
                (
                    "employee",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="holiday_entitlements",
                        to="timetracker.timetrackeremployee",
                    ),
                ),
            ],
            options={
                "verbose_name": "Holiday entitlement",
                "verbose_name_plural": "Holiday entitlements",
                "ordering": ["start_date"],
            },
        ),
        migrations.CreateModel(
            name="HolidayPolicy",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "created",
                    models.DateTimeField(
                        default=django.utils.timezone.now, editable=False
                    ),
                ),
                (
                    "modified",
                    medux.common.models.AutoDateTimeField(
                        default=django.utils.timezone.now
                    ),
                ),
                ("name", models.CharField(max_length=255, verbose_name="Name")),
                (
                    "days_per_year",
                    models.PositiveSmallIntegerField(
                        default=30,
                        help_text="Holidays per year, when a 6-days week is assumed.",
                    ),
                ),
                (
                    "holiday_expiration",
                    models.BooleanField(
                        default=False,
                        help_text="Holidays expire after time.",
                        verbose_name="Holidays expire",
                    ),
                ),
                (
                    "holiday_expiration_months",
                    models.PositiveSmallIntegerField(
                        blank=True,
                        default=0,
                        help_text="Holidays expire these months after they are created.",
                        verbose_name="Holidays expire after",
                    ),
                ),
                (
                    "is_active",
                    models.BooleanField(
                        default=True,
                        help_text="Uncheck this to hide this policy.",
                        verbose_name="Active",
                    ),
                ),
                (
                    "is_standard",
                    models.BooleanField(
                        default=False,
                        help_text="This is the standard policy for this tenant.",
                        verbose_name="Standard",
                    ),
                ),
                (
                    "absence_type",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.PROTECT,
                        to="timetracker.absencetype",
                        verbose_name="Type",
                    ),
                ),
            ],
            options={
                "verbose_name": "Holiday policy",
                "verbose_name_plural": "Holiday policies",
                "ordering": ["name"],
            },
        ),
        migrations.CreateModel(
            name="HolidayPolicyApplication",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "application_date",
                    models.DateField(
                        help_text="The date the rule applies",
                        verbose_name="Application date",
                    ),
                ),
                (
                    "employee",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="timetracker.timetrackeremployee",
                    ),
                ),
                (
                    "holiday_policy",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="timetracker.holidaypolicy",
                    ),
                ),
            ],
            options={
                "unique_together": {("employee", "holiday_policy", "application_date")},
            },
        ),
        migrations.CreateModel(
            name="WorkSchedule",
            fields=[],
            options={
                "proxy": True,
                "indexes": [],
                "constraints": [],
            },
            bases=("employees.workschedule",),
        ),
        migrations.AlterField(
            model_name="absence",
            name="day",
            field=models.DateField(verbose_name="Date"),
        ),
        migrations.AlterField(
            model_name="absence",
            name="employee",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                to="timetracker.timetrackeremployee",
                verbose_name="Employee",
            ),
        ),
        migrations.DeleteModel(
            name="YearSummary",
        ),
        migrations.AddField(
            model_name="holidaypolicy",
            name="employees",
            field=models.ManyToManyField(
                related_name="holiday_policies",
                through="timetracker.HolidayPolicyApplication",
                to="timetracker.timetrackeremployee",
                verbose_name="Employees using this policy",
            ),
        ),
        migrations.AddField(
            model_name="holidaypolicy",
            name="tenant",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, to="common.tenant"
            ),
        ),
        migrations.AddField(
            model_name="holidayentitlement",
            name="work_schedule",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="holiday_entitlements",
                to="timetracker.workschedule",
            ),
        ),
        migrations.AddField(
            model_name="absencebalance",
            name="absence_type",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.PROTECT,
                to="timetracker.absencetype",
            ),
        ),
        migrations.AddField(
            model_name="absencebalance",
            name="employee",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                to="timetracker.timetrackeremployee",
            ),
        ),
        migrations.AlterUniqueTogether(
            name="absence",
            unique_together=set(),
        ),
        migrations.AddField(
            model_name="absence",
            name="absence_type",
            field=models.ForeignKey(
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                to="timetracker.absencetype",
                verbose_name="Type",
            ),
        ),
        migrations.AlterField(
            model_name="timeentry",
            name="work_schedule",
            field=models.ForeignKey(
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="time_entries",
                to="timetracker.workschedule",
            ),
        ),
        migrations.AlterUniqueTogether(
            name="absence",
            unique_together={("day", "employee", "absence_type")},
        ),
        RunPython(create_vendor_absencetype_presets, RunPython.noop),
        RunPython(migrate_absence_types, RunPython.noop),
        migrations.RemoveField(
            model_name="absence",
            name="type",
        ),
    ]
